/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _FILTERC_H
#define _FILTERC_H

#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>


#define FILTER_BOOLEAN_CHANNEL		1
#define FILTER_BOOLEAN_OWNER		2


typedef struct _FILTER
{
    LONG    Channel;
    LONG    PktDataOffset;
    BYTE*   PktData;
    BYTE*   PktDataMask;
    BYTE*   PktDataNotMask;
    BOOLEAN PktDataNotMaskAllZero;
    WORD    PktDataLen;
    WORD    PktDataMaskLen;
    WORD    PktDataNotMaskLen;
    LONG    PktStatus;
    LONG    PktStatusMask;
    LONG    PktStatusNotMask;
    BYTE    Owner[SNMP_SIZE_BUFCHR];
    WORD    OwnerLen;
    LONG    Status;

    BooleanSet ObjectSet;

} FILTER;


BOOLEAN FilterCInit(FILTER *filter);
BOOLEAN FilterCStart(FILTER *filter);
BOOLEAN FilterCStop(FILTER *filter);


#endif
