/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <dnpap.h>
#include <stdlib.h>
#include <dlog.h>

#include "deventd.h"
#include "deventc.h"


IMPORT BOOLEAN BeholderStrictRMON;


static CHAR MODULE[] = "DnpapEventC";


BOOLEAN DnpapEventCInit(DnpapRmonEvent* event)
{
	event->Description[0] = '\0';
    event->DescrLen = 0;
	event->Type = DEVENT_NONE;
	event->Community[0] = '\0';
    event->CommLen = 0;
	event->LastTimeSent = 0;
	event->Owner[0] = '\0';
	event->OwnerLen = 0;
	event->Status = SNMP_INVALID;
	
	event->NrLogs = 0;
	event->LogPos = 0;
	event->LogIndex = 1;
	event->LogBounced = FALSE;
	event->Logs = NULL;
	
	BooleanSetAllTrue(event->ObjectSet);
	BooleanSetFalse(event->ObjectSet, EVENT_BOOLEAN_COMMUNITY);
	BooleanSetFalse(event->ObjectSet, EVENT_BOOLEAN_OWNER);

    return TRUE;
}


BOOLEAN DnpapEventCStart(DnpapRmonEvent* event)
{
	if (BeholderStrictRMON && !BooleanCheckAllTrue(event->ObjectSet))
		return FALSE;

    return TRUE;
}


BOOLEAN DnpapEventCStop(DnpapRmonEvent* event)
{
	DelDnpapRmonLog(event->Logs);
	
    return TRUE;
}


DnpapRmonEvent* NewDnpapRmonEvent(WORD nrevents)
{
    return DnpapMalloc(nrevents*sizeof(DnpapRmonEvent));
}


DnpapRmonEvent* ReNewDnpapRmonEvent(DnpapRmonEvent* ptr, WORD nrevents)
{
    return DnpapRealloc(ptr, nrevents*sizeof(DnpapRmonEvent));
}


VOID DelDnpapRmonEvent(DnpapRmonEvent* ptr)
{
    DnpapFree(ptr);
}
